﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Olap.FlatData;
using Infragistics.Olap;
using Infragistics.Controls.Grids;
using Infragistics.Olap.Data;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;
using System.Diagnostics;
using Infragistics.Olap.Data.Base;
using System.Linq.Expressions;
using System.Threading;

namespace TestApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        FlatDataSource dataSource;
        public MainWindow()
        {
            InitializeComponent();

            Data = new ObservableCollection<Data>();
            Random r = new Random();

            for (int i = 0; i < 50; i++)
            {
                

                int days = i % 5;
                Data.Add(new Data
                {
                    Test = "Test" + r.Next(10),
                    Result = r.Next(5000),
                    Date = DateTime.Now.AddDays(days + 10)
                });
            }

        }

        public ObservableCollection<Data> Data { get; set; }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            string mStr = "Result";

            dataSource = new FlatDataSource()
            {
                ItemsSource = Data,
                Cube = DataSourceBase.GenerateInitialCube("Test Results"),
                Rows = DataSourceBase.GenerateInitialItems("[Test].[Test]"),
                Columns = DataSourceBase.GenerateInitialItems("[Date].[Date]"),
                Measures = DataSourceBase.GenerateInitialItems(mStr)
               
            };
            
            xamPivotGrid1.DataSource = dataSource;
        }

        private void Button_Click(object sender, RoutedEventArgs args)
        {
            ShouldExpand = true;
            foreach (PivotHeaderCell cell in xamPivotGrid1.GridLayout.ColumnHeaderCells)
            {
                if (cell.IsToggleVisible && cell.IsExpanded == false)
                {
                    cell.IsExpanded = true;
                    return;
                }
            }
        }


        void DataSource_ResultChanged(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            DataSourceBase dataSourceBase = (DataSourceBase)sender;
            dataSourceBase.ResultChanged -= this.DataSource_ResultChanged;

            dataSourceBase.HierarchyExpansionMode = HierarchyExpansionMode.DrillDown;
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Rows);
            dataSourceBase.UpdateVisualMembers(Infragistics.Olap.ExecutionContext.Columns);
            dataSourceBase.HierarchyExpansionMode = HierarchyExpansionMode.SingleLevelOnly;

            dataSourceBase.RefreshGrid();
        }

       

        private IFilterViewModel FindDateViewModel(DataSourceBase dataSource)
        {

            for (int i = 0; i < dataSource.Rows.Count; i++)
            {
                if ((dataSource.Rows[i] as IFilterViewModel).Caption == "Date")
                {
                    return dataSource.Rows[i] as IFilterViewModel;
                }
            }

            for (int i = 0; i < dataSource.Columns.Count; i++)
            {
                if ((dataSource.Columns[i] as IFilterViewModel).Caption == "Date")
                {
                    return dataSource.Columns[i] as IFilterViewModel;
                }
            }

            return null;
        }

        private void xamPivotGrid1_LayoutUpdated(object sender, EventArgs e)
        {
            if (ShouldExpand)
            {
                try
                {
                    if (xamPivotGrid1.GridLayout != null && xamPivotGrid1.GridLayout.ColumnHeaderCells != null)
                    {
                        foreach (PivotHeaderCell cell in xamPivotGrid1.GridLayout.ColumnHeaderCells)
                        {
                            if (cell.IsToggleVisible && cell.IsExpanded == false)
                            {
                                cell.IsExpanded = true;
                                return;
                            }
                        }
                    }
                }
                catch (Exception)
                { }
            }
        }

        bool ShouldExpand = false;
        
    }

   


    public class Data : INotifyPropertyChanged
    {

        public string Test
        {
            get { return test; }
            set
            {
                test = value;
                OnPropertyChanged("Test");
            }
        }

        public int Result
        {
            get { return result; }
            set
            {
                result = value;
                OnPropertyChanged("Result");
            }
        }

        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                OnPropertyChanged("Date");
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        private string test;
        private int result;
        private DateTime date;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

}
